--
-- Insurance Specialization for all machines
-- by Blacky_BPG
--

Insurance = {};
Insurance.stat = {};
Insurance.modDir = g_currentModDirectory;
Insurance.lasttime = 2700;

function Insurance.prerequisitesPresent(specializations)
	return true;
end;

function Insurance:load(xmlFile)
	self.insurance = 0;
	self.insuranceCount = 0;
	self.NextDay = g_currentMission.environment.currentDay + 2;
	self.NextHour = g_currentMission.environment.currentHour;
	self.showInsuranceHud = false;
	self.InsuranceHud = Overlay:new("Insurancehud", (Insurance.modDir.."huds/OverlayText.dds"), 0.2, 0.15, 0.6, 0.7);
	self.Insprice = 0;
	self.InsdailyUpkeep = 0;
	self.hudPage = 0;
	self.hudPaper = 0;
	self.maxVeh = 0;

	local name = getXMLString(xmlFile, "vehicle.name.de");
	name = Utils.getNoNil(name, getXMLString(xmlFile, "vehicle.name.en"));
	name = Utils.getNoNil(getXMLString(xmlFile, "vehicle.name"), name);
	name = Utils.getNoNil(name,getXMLString(xmlFile, "vehicle#type"));
	self.name = name;

	self.addInsurance = SpecializationUtil.callSpecializationsFunction("addInsurance");

	if g_currentMission.Insurances == nil then
		g_currentMission.Insurances = {};
		g_currentMission.Insurances.session = 0;
		g_currentMission.Insurances.total = 0;
		g_currentMission.Insurances.vehicles = {};
	end;

	if self.insurance == 0 then
		local str1 = self.configFileName;
		for z=1, table.getn(StoreItemsUtil.storeItems) do
			local str2 = StoreItemsUtil.storeItems[z].xmlFilename;
			if StoreItemsUtil.storeItems[z].species == nil or StoreItemsUtil.storeItems[z].species == "" then
				if str1 == str2 then
					self.insurance = (((StoreItemsUtil.storeItems[z].price * 0.003) * g_currentMission.missionStats.difficulty) + (StoreItemsUtil.storeItems[z].dailyUpkeep * 0.5));
					self.iCD = StoreItemsUtil.storeItems[z].price;
					self.InsdailyUpkeep = StoreItemsUtil.storeItems[z].dailyUpkeep;
					self.Insprice = StoreItemsUtil.storeItems[z].price;
				end;
			end;
		end;
	end;

	local myTable = {}
	myTable.insurance = self.insurance;
	myTable.name = self.name;
	myTable.insuranceCount = self.insuranceCount;
	myTable.InsdailyUpkeep = self.InsdailyUpkeep;
	myTable.Insprice = self.Insprice;
	myTable.NextDay = self.NextDay;
	myTable.NextHour = self.NextHour

	table.insert(g_currentMission.Insurances.vehicles, myTable);
	self.tblPos = table.getn(g_currentMission.Insurances.vehicles);

	self.ticker2 = 50;

end;

function Insurance:delete()
	g_currentMission.Insurances.vehicles[self.tblPos].insurance = 0;
end;

function Insurance:readStream(streamId, connection)
	if self.insurance == 0 then
		return
	end;
	self.insurance = streamReadFloat32(streamId), true;
	self.insuranceCount = streamReadFloat32(streamId), true;
	self.NextDay = streamReadFloat32(streamId), true;
	self.NextHour = streamReadFloat32(streamId), true;
end;

function Insurance:writeStream(streamId, connection)
	if self.insurance == 0 then
		return
	end;
	streamWriteFloat32(streamId, self.insurance);
	streamWriteFloat32(streamId, self.insuranceCount);
	streamWriteFloat32(streamId, self.NextDay);
	streamWriteFloat32(streamId, self.NextHour);
end;

function Insurance:mouseEvent(posX, posY, isDown, isUp, button)
	if self.showInsuranceHud then
		if isDown and button == 1 then
			if posX > 0.222 and posX < 0.238 and posY > 0.222 and posY < 0.242 then
				self.hudPage = self.hudPage - 1;
				if self.hudPage < 0 then
					self.hudPage = 0;
				end;
			end;
			if posX > 0.754 and posX < 0.767 and posY > 0.222 and posY < 0.242 then
				self.hudPage = self.hudPage + 1;
				local max = (self.hudPage * 50) + 1;
				if table.getn(g_currentMission.Insurances.vehicles) < self.maxVeh then
					self.hudPage = self.hudPage - 1;
				end;
			end;
		end;
	end;
end;

function Insurance:keyEvent(unicode, sym, modifier, isDown)
end;

function Insurance:update(dt)
	if self.insurance == nil then
		self.insurance = -1;
		local str1 = string.lower(self.configFileName);
		for z=1, table.getn(StoreItemsUtil.storeItems) do
			local str2 = string.lower(StoreItemsUtil.storeItems[z].xmlFilename);
			if StoreItemsUtil.storeItems[z].species == nil or StoreItemsUtil.storeItems[z].species == "" then
				if str1 == str2 then
					self.insurance = (((StoreItemsUtil.storeItems[z].price * 0.003) * g_currentMission.missionStats.difficulty) + (StoreItemsUtil.storeItems[z].dailyUpkeep * 0.5));
					self.InsdailyUpkeep = StoreItemsUtil.storeItems[z].dailyUpkeep;
					self.Insprice = StoreItemsUtil.storeItems[z].price;
				end;
			end;
		end;
		if self.insurance > 0 then
			if self.NextHour == 0 or self.NextHour == nil then
				self.NextHour = g_currentMission.environment.currentHour;
			end;
			if self.NextDay == 0 or self.NextDay == nil then
				self.NextDay = g_currentMission.environment.currentDay + 2;
			end;
			g_currentMission.Insurances.total = g_currentMission.Insurances.total + (self.insurance * self.insuranceCount);
			self.insuranceCount = 0;
			if self.tblPos ~= nil then
				g_currentMission.Insurances.vehicles[self.tblPos].name = self.name;
				g_currentMission.Insurances.vehicles[self.tblPos].insurance = self.insurance;
				g_currentMission.Insurances.vehicles[self.tblPos].InsdailyUpkeep = self.InsdailyUpkeep;
				g_currentMission.Insurances.vehicles[self.tblPos].Insprice = self.Insprice;
				g_currentMission.Insurances.vehicles[self.tblPos].NextDay = self.NextDay;
				g_currentMission.Insurances.vehicles[self.tblPos].NextHour = self.NextHour;
				g_currentMission.Insurances.vehicles[self.tblPos].insuranceCount = self.insuranceCount;
			else
				local myTable = {}
				myTable.insurance = self.insurance;
				myTable.name = self.name;
				myTable.insuranceCount = self.insuranceCount;
				myTable.InsdailyUpkeep = self.InsdailyUpkeep;
				myTable.Insprice = self.Insprice;
				myTable.NextDay = self.NextDay;
				myTable.NextHour = self.NextHour
				table.insert(g_currentMission.Insurances.vehicles, myTable);
				self.tblPos = table.getn(g_currentMission.Insurances.vehicles);
			end;
		end;
	end;

	if self.insurance == 0 or self.insurance == -1 then
		return
	end;
	local myDay = g_currentMission.environment.currentDay;
	local myHour = g_currentMission.environment.currentHour;
	if myDay == self.NextDay then
		if myHour == self.NextHour then
			self.NextDay = self.NextDay + 2;
			g_currentMission.missionStats.expensesTotal = g_currentMission.missionStats.expensesTotal + self.insurance;
			g_currentMission.missionStats.expensesSession = g_currentMission.missionStats.expensesSession + self.insurance;
			g_currentMission.Insurances.total = g_currentMission.Insurances.total + self.insurance;
			g_currentMission.Insurances.session = g_currentMission.Insurances.session + self.insurance;
			if g_server == nil then
			else
				g_currentMission:addSharedMoney(-self.insurance, "vehicleRunningCost");
			end;
			self.insuranceCount = self.insuranceCount + 1;
			g_currentMission.Insurances.vehicles[self.tblPos].insuranceCount = self.insuranceCount;
			g_currentMission.Insurances.vehicles[self.tblPos].NextDay = self.NextDay;
		end;
	end;
	if self:getIsActiveForInput() or self:getIsActiveForInput(false) then
		if InputBinding.hasEvent(InputBinding.VehicleInfo) then
			self.showInsuranceHud = (not self.showInsuranceHud);
			InputBinding.setShowMouseCursor(self.showInsuranceHud);
		end;
	end;
end;

function Insurance:updateTick(dt)
	if self.insurance == 0 then
		return
	end;
	if Insurance.lasttime == 0 then
		if self.addInsurance ~= nil then
			self:addInsurance(self.insurance, self.insuranceCount, self.NextDay, self.NextHour);
		end;
		Insurance.lasttime = math.random(2500,2750);
	else
		Insurance.lasttime = Insurance.lasttime - 1;
	end;
end;

function Insurance:onLeave()
	if self.showInsuranceHud == true then
		self.showInsuranceHud = (false);
		InputBinding.setShowMouseCursor(false);
	end;
end;

function Insurance:onEnter()
end;

function Insurance:draw()
	if self.showInsuranceHud == true then
		local gcMVeh = g_currentMission.Insurances.vehicles;
		local pda = g_currentMission.missionPDA;
		local PosX = 0.237;
		local PosXLine = 0.233;
		local PosXTab = 0.47;
		local PosY = 0.755;
		local lSpace = 0.02;
		local fSize = pda.pdaFontSize - 0.002;
		local vCount = 0;
		self.InsuranceHud:render();
		self.hudPaper = 0;
		local InsVeh = 0;
		local InsSum = 0;
		setTextBold(true);
		setTextColor(0,0.35,0,1);
		setTextAlignment(RenderText.ALIGN_LEFT);
		renderText(0.235,0.785,fSize+0.01,g_i18n:getText("PDAEFS_Versicherung"));
		setTextBold(false);
		setTextColor(0.4,0,0,1);
		setTextAlignment(RenderText.ALIGN_LEFT);
		renderText(0.507,0.8,fSize-0.0035,g_i18n:getText("PDAEFS_VersicherungInfo"));
		local page = (self.hudPage * 50) + 1;
		for i=1, table.getn(gcMVeh) do
			if gcMVeh[i] ~= nil and gcMVeh[i].insurance > 0 then
				self.maxVeh = self.maxVeh + 1;
				InsSum = InsSum + gcMVeh[i].insurance;
				InsVeh = InsVeh + 1;
			end;
		end;
		for i=page, table.getn(gcMVeh) do
			if gcMVeh[i] ~= nil and gcMVeh[i].insurance > 0 then
				vCount = vCount + 1;
				if vCount > 25 then
					self.hudPaper = self.hudPaper + 1;
					PosY = 0.755;
					PosX = 0.509;
					PosXLine = 0.509;
					PosXTab = 0.742;
					vCount = 0;
				end;
				local rHours = gcMVeh[i].NextHour - g_currentMission.environment.currentHour;
				rHours = rHours + ((gcMVeh[i].NextDay - g_currentMission.environment.currentDay) * 24);
				if self.hudPaper <= 1 then
					setTextBold(false);
					setTextColor(0,0,0.35,1);
					setTextAlignment(RenderText.ALIGN_LEFT);
					renderText(PosX,PosY,fSize,tostring(gcMVeh[i].name).." ("..tostring(rHours)..")");
					setTextColor(0.55,0.55,0.55,1);
					renderText(PosXLine,PosY-0.00065,fSize,"______________________________________");
					setTextColor(0,0,0.35,1);
					setTextAlignment(RenderText.ALIGN_RIGHT);
					renderText(PosXTab,PosY,fSize,tostring(string.format("%1.2f",gcMVeh[i].insurance)).." "..g_i18n:getText("PDAEFS_Euro"));
					PosY = PosY - lSpace;
				end;
			end;
		end;
		setTextBold(false);
		setTextColor(0.4,0,0,1);
		setTextAlignment(RenderText.ALIGN_LEFT);
		renderText(0.237,0.242,fSize,g_i18n:getText("PDAEFS_VersicherungFahrzeuge"));
		setTextAlignment(RenderText.ALIGN_RIGHT);
		renderText(0.46,0.242,fSize,tostring(InsVeh));
		setTextAlignment(RenderText.ALIGN_LEFT);
		renderText(0.509,0.242,fSize,g_i18n:getText("PDAEFS_VersicherungGesamt"));
		setTextAlignment(RenderText.ALIGN_RIGHT);
		renderText(0.742,0.242,fSize,string.format("%1.2f",InsSum).." "..g_i18n:getText("PDAEFS_Euro"));
		setTextBold(false);
		setTextColor(0.4,0.4,0.4,1);
		setTextAlignment(RenderText.ALIGN_LEFT);
		local fp = (self.hudPage * 2);
		renderText(0.24,0.228,fSize-0.003,"Seite "..tostring(fp + 1));
		setTextAlignment(RenderText.ALIGN_RIGHT);
		renderText(0.750,0.228,fSize-0.003,"Seite "..tostring(fp + 2));
		setTextColor(1,1,1,1);
		setTextAlignment(RenderText.ALIGN_LEFT);
		setTextBold(false);
	else
		self.maxVeh = 0;
	end;
end;

function Insurance:addInsurance(ins,insT,nDay,nHour, noEventSend)
	if self.insurance == 0 then
		return
	end;
	self.insurance = ins;
	self.insuranceCount = insT;
	self.NextDay = nDay;
	self.NextHour = nHour;
	InsuranceEvent.sendEvent(self, ins, insT,nDay,nHour, noEventSend);
end;

function Insurance:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
	local insurance = Utils.getNoNil(getXMLFloat(xmlFile, key .. "#insurance"), self.insurance);
	local insuranceCount = Utils.getNoNil(getXMLFloat(xmlFile, key .. "#insuranceCount"), self.insuranceCount);
	local NextDay = Utils.getNoNil(getXMLFloat(xmlFile, key .. "#insuranceNextDay"), self.NextDay);
	local NextHour = Utils.getNoNil(getXMLFloat(xmlFile, key .. "#insuranceNextHour"), self.NextHour);
	if NextHour <= 0 then
		NextHour = g_currentMission.environment.currentHour;
	end;
	if NextDay <= 0 then
		NextDay = g_currentMission.environment.currentDay + 2;
	end;

	local rHours = NextHour - g_currentMission.environment.currentHour;
	rHours = rHours + ((NextDay - g_currentMission.environment.currentDay) * 24);
	if rHours < 0 then
		NextDay = g_currentMission.environment.currentDay;
		NextHour = g_currentMission.environment.currentHour + 1;
	end;

	if insurance == 0 then
		local str1 = string.lower(self.configFileName);
		for z=1, table.getn(StoreItemsUtil.storeItems) do
			local str2 = string.lower(StoreItemsUtil.storeItems[z].xmlFilename);
			if StoreItemsUtil.storeItems[z].species == nil or StoreItemsUtil.storeItems[z].species == "" then
				if str1 == str2 then
					self.insurance = (((StoreItemsUtil.storeItems[z].price * 0.003) * g_currentMission.missionStats.difficulty) + (StoreItemsUtil.storeItems[z].dailyUpkeep * 0.5));
					self.InsdailyUpkeep = StoreItemsUtil.storeItems[z].dailyUpkeep;
					self.Insprice = StoreItemsUtil.storeItems[z].price;
				end;
			end;
		end;
	end;

	g_currentMission.Insurances.total = g_currentMission.Insurances.total + (self.insurance * self.insuranceCount);

	self.insurance = insurance;
	self.insuranceCount = insuranceCount;
	self.NextHour = NextHour;
	self.NextDay = NextDay;

	if self.tblPos ~= nil then
		g_currentMission.Insurances.vehicles[self.tblPos].name = self.name;
		g_currentMission.Insurances.vehicles[self.tblPos].insurance = self.insurance;
		g_currentMission.Insurances.vehicles[self.tblPos].InsdailyUpkeep = self.InsdailyUpkeep;
		g_currentMission.Insurances.vehicles[self.tblPos].Insprice = self.Insprice;
		g_currentMission.Insurances.vehicles[self.tblPos].NextDay = self.NextDay;
		g_currentMission.Insurances.vehicles[self.tblPos].NextHour = self.NextHour;
		g_currentMission.Insurances.vehicles[self.tblPos].insuranceCount = self.insuranceCount;
	else
		local myTable = {}
		myTable.insurance = self.insurance;
		myTable.name = self.name;
		myTable.insuranceCount = self.insuranceCount;
		myTable.InsdailyUpkeep = self.InsdailyUpkeep;
		myTable.Insprice = self.Insprice;
		myTable.NextDay = self.NextDay;
		myTable.NextHour = self.NextHour

		table.insert(g_currentMission.Insurances.vehicles, myTable);
		self.tblPos = table.getn(g_currentMission.Insurances.vehicles);
	end;

	return BaseMission.VEHICLE_LOAD_OK;
end;

function Insurance:getSaveAttributesAndNodes(nodeIdent)
	if self.insurance == 0 then
		return
	end;
	local attributes = 'insurance="'.. self.insurance .. '" insuranceCount="'..self.insuranceCount..'" insuranceNextDay="'..self.NextDay..'" insuranceNextHour="'..self.NextHour..'"';

	return attributes, nil;
end;

InsuranceEvent = {};
InsuranceEvent_mt = Class(InsuranceEvent, Event);

InitEventClass(InsuranceEvent, "InsuranceEvent");

function InsuranceEvent:emptyNew()
    local self = Event:new(InsuranceEvent_mt);
    self.className="InsuranceEvent";
    return self;
end;

function InsuranceEvent:new(vehicle, ins, insT, nDay, nHour)
	local self = InsuranceEvent:emptyNew()
	self.vehicle = vehicle;
	self.insurance = ins;
	self.insuranceCount = insT;
	self.NextDay = nDay;
	self.NextHour = nHour;
	return self;
end;

function InsuranceEvent:readStream(streamId, connection)
	local id = streamReadInt32(streamId);
	self.insurance = streamReadFloat32(streamId);
	self.insuranceCount = streamReadFloat32(streamId);
	self.NextDay = streamReadFloat32(streamId);
	self.NextHour = streamReadFloat32(streamId);
	self.vehicle = networkGetObject(id);
	self:run(connection);
end;

function InsuranceEvent:writeStream(streamId, connection)
	streamWriteInt32(streamId, networkGetObjectId(self.vehicle));
	streamWriteFloat32(streamId, self.insurance);
	streamWriteFloat32(streamId, self.insuranceCount);
	streamWriteFloat32(streamId, self.NextDay);
	streamWriteFloat32(streamId, self.NextHour);
end;

function InsuranceEvent:run(connection)
	if self.vehicle ~= nil then
		if not connection:getIsServer() then
			g_server:broadcastEvent(InsuranceEvent:new(self.vehicle, self.insurance, self.insuranceCount, self.NextDay, self.NextHour), nil, connection, self.vehicle);
		end;
		self.vehicle:addInsurance(self.insurance, self.insuranceCount,self.NextDay,self.NextHour, true);
	end;
end;

function InsuranceEvent.sendEvent(vehicle, ins, insT, nDay, nHour, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(InsuranceEvent:new(vehicle, ins, insT, nDay, nHour), nil, nil, vehicle);
		end;
	end;
end;

